/***********************************************************************
 * ein weiteres wenig sinnvolles programm fr die dbox2 (C) 2001 Ge0rG *
 *                                                                     *
 * Dieses Programm unterliegt der GPL, also nix klauen ;o)             *
 ***********************************************************************/

#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <string.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>

//#include "lcd-ks0713.h"
#include "liblcd.h"
#include "ani.h"


int main(int argc, char *args[]) {
	int lcd_fd;
	FILE *f;
	struct ani_header ah;
	lcd_packed_buffer *ani;
	int t, loop, loopcount;
	struct timeval time1, time2;
	unsigned long real_delay;

	if (argc < 2) {
		printf("aniplay (C) 2001 Ge0rG\n");
		printf("	%s <file.ani> [<loopcount>]\n");
		exit(1);
	}
	loopcount=0;
	if (argc==3) loopcount=atoi(args[2]);

	f = fopen(args[1], "r");
	fread(&ah, 1, sizeof(ah), f);
	ah_ntoh(&ah);

	ani = malloc(sizeof(screen_t)*ah.count);
	fread(ani, sizeof(screen_t), ah.count, f);
	fclose(f);


	lcd_fd = lcd_open();

	t = 0;
	loop = 0;
	while ((loop<loopcount) || (loopcount==0)) {
		for (t=0; t<ah.count; t++) {
			if (0==gettimeofday(&time1, NULL)) {
			} else perror("gettimeofday(1)");
			lcd_write(lcd_fd, ani[t]);
			if (0==gettimeofday(&time2, NULL)) {
				real_delay = time2.tv_sec - time1.tv_sec;
				real_delay = real_delay*1000000 + time2.tv_usec - time1.tv_usec;
				//printf("%lu\n", real_delay);
				// filter out nonsense values
				if (real_delay > ah.delay) {
					real_delay = ah.delay;
				} else {
					real_delay = ah.delay - real_delay;
				}
			} else {
				perror("gettimeofday(2)");
				real_delay = ah.delay;
			}
			usleep(real_delay);
		}
		loop++;
	}
	lcd_close(lcd_fd);
	return 0;
}
